#include    <WinUser32.mqh>
#import "user32.dll"
int GetAncestor(int, int);
#import

extern string    A = "------Pause during backtest------";
extern bool      Use_Pause   = true;
extern string    AA = "------Time Filter------";
extern bool      Use_Timefilter = false;
extern int       StartHour            = 10,
                 EndHour              = 11;

extern string    B = "------TRADE SETTINGS------";
extern string    BC = "------set lots, final TP and number of trades------";
extern double    lots           = 1;
extern int       TP_Points      = 125;
extern int       Max_long_Orders = 1;
extern int       Max_short_Orders = 1;

extern string    C = "------Use last high / low for SL------";
extern bool      Use_last_high_or_low_for_sl = true;
extern int       Min_SL_Points      = 10;
extern int       Max_SL_Points      = 50;
extern string    CC = "If Use_last_high_or_low_for_sl = false, then select here a fix Sl------";
extern int       SL_Points      = 50;

extern string    D = "------Skip SL to settings------";
extern bool      Use_Skip_SL_to = true;

extern string    E = "------at X pips profit the SL is trailed to Y pips profit------" ;
extern int       SL_EDGE_1           =  25;
extern int       SL_profit_points_1  =   5;
extern int       SL_EDGE_2           =  60;
extern int       SL_profit_points_2  =  30;
extern int       SL_EDGE_3           = 100;
extern int       SL_profit_points_3  =  75;
extern int       SL_EDGE_4           = 140;
extern int       SL_profit_points_4  = 100;
extern int       SL_EDGE_5           = 200;
extern int       SL_profit_points_5  = 160;
extern int       SL_EDGE_6           = 260;
extern int       SL_profit_points_6  = 200;
extern int       SL_EDGE_7           = 320;
extern int       SL_profit_points_7  = 300;

extern string    F = "------at X pips loss the takeprofit ist skiped to zero------" ;
extern bool      Use_Rescue = true;
extern int       start_rescue_pips = 10;

extern string    G = "------CCI settings------";
extern bool      Use_CCI      = true;
extern int       CCI_Period   = 14;

extern string    H = "------CCI Trend settings------";
extern bool      Use_CCI_trend      = true;
extern int       CCI_trend_Period   = 14;

extern string    I = "------ZigZag settings------";
extern int       ExtDepth       = 12;
extern int       ExtDeviation   = 5;
extern int       ExtBackstep    = 3;

extern string    J= "------trend settings (EMA Price Median)------";       
extern bool      Use_trend      = true;
extern int       MA_Period      = 50;
extern int       min_distance_to_MA = 100;

int         Pending_BUY = 0;
int         Pending_SELL = 0;
int         BUY = 0;
int         SELL = 0;

double      p0,p1,p2,p3,p4,p5;
double      p3_trade_long;
double      p3_trade_short;

double      p3_old,
            p4_old;

double      StoppLoss;
double      TakeProfit;
int         ticket;

//init
double      Min_Distance;
double      Spread;
double      pips2dbl;
//loop
int         b;
//Draw Line
int         OrdersTotal_old;
int         line_color;
int         number;
//Timefilter
bool        new_trade_allowed;
//trendcheck
double      MA;
bool        buy_allowed;
bool        sell_allowed;

/////////////////////////////////////////////////////////////////////////////
int init()
{
  //check for 4 or 5 digits
  if (Digits == 5 || Digits == 3)    // Adjust for five (5) digit brokers.
  {pips2dbl = Point*10;} else {pips2dbl = Point;}

  //check min distance from ask/bid to place a pending order
  Min_Distance = MarketInfo(Symbol(),MODE_STOPLEVEL)*pips2dbl;
  Spread = MarketInfo(Symbol(),MODE_SPREAD)*pips2dbl;
 return(0);
}
/////////////////////////////////////////////////////////////////////////////

int start()
{

//Count Orders (open and pending)--------------------------------------------
Pending_BUY = 0;
Pending_SELL = 0;
BUY = 0;
SELL = 0;
for(b=OrdersTotal()-1;b>=0;b--)
   {
      if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES)==true)
       {
         if (OrderType()        == OP_BUYSTOP)
         Pending_BUY++;

         if (OrderType()        == OP_SELLSTOP)
         Pending_SELL++;

         if (OrderType()        == OP_BUY)
         BUY++;

         if (OrderType()        == OP_SELL)
         SELL++;
       }
    }
//Count Orders (open and pending) finish--------------------------------------

//Check time for Timefilter---------------------------------------------------
new_trade_allowed = true;

if(Use_Timefilter ==true)
   {
    if(Hour()>=StartHour && Hour()<=EndHour)
    new_trade_allowed = false;
   }
//Check time for Timefilter finish--------------------------------------------




   call_zigzag();
   trendcheck();
   trade();
   Skip_SL_to();
   rescue();
   draw_line();

  return(0);
}


/////////////////////////////////////////////////////////////////////////////
void call_zigzag ()
{
//This function calls the custom indicator zigzag and returns its values. THE INDICATOR ZIGZAG MUST BE IN THE FOLDER C:\...\MetaTrader 4\experts\indicators AND MUST BE NAMED "zigzag"!!!!
   int n, i = 0;

      while(n<6)
      {
      if(p0>0) {p5=p4; p4=p3; p3=p2; p2=p1; p1=p0; }
      p0=iCustom(Symbol(),0,"zigzag",ExtDepth,ExtDeviation,ExtBackstep,0,i);
      if(p0>0) {n+=1; }
      i++;
      }

}
/////////////////////////////////////////////////////////////////////////////
void trade ()
{
//calculate CCI
double CCI=iCCI(Symbol(),0,CCI_Period,PRICE_TYPICAL,0);

//calculate RSI
double CCI_trend=iCCI(Symbol(),0,CCI_trend_Period,PRICE_TYPICAL,0);

//Place buy--------------------------------------------------------------------------

// Low 2 is higher than low 1 and high 2 is higher than high 1

 if(Use_CCI == false) CCI = 0;
 if(Use_CCI_trend == false) CCI_trend = 0;


   if(
        p4                    <  p3                   &&
        p4                    >  p2                   &&
        //p4                    >  p1                   &&
        p3                    >  p2                   &&
        //p3                    >  p1                   &&
        //p2                    <  p1                   &&
        p5                    >  p4                   &&
        BUY                   <= Max_long_Orders      &&
        p3                    != p3_trade_long        &&
        CCI                   >  100                  &&
        Ask                   >= p3                   &&
        new_trade_allowed     == true                 &&
        buy_allowed           == true                      //trend check
       )
     {
      StoppLoss  = NormalizeDouble(p3,4)-SL_Points*pips2dbl;
      if(Use_last_high_or_low_for_sl == true)
      {
       StoppLoss = p4;
       if(Ask - p4  < Min_SL_Points*pips2dbl)
       StoppLoss  = NormalizeDouble(Ask,4)-Min_SL_Points*pips2dbl;
       if(Ask - p4  > Max_SL_Points*pips2dbl)
       StoppLoss  = NormalizeDouble(Ask,4)-Max_SL_Points*pips2dbl;
      }
      TakeProfit = NormalizeDouble(p3,4)+TP_Points*pips2dbl;
      ticket=OrderSend(Symbol(),OP_BUY, lots,Ask,1,StoppLoss,TakeProfit,"Ordername",1,0,Green);
      p3_trade_long = p3;
      PauseTest();
     }

//Place buy finish--------------------------------------------------------------------

//Place sell--------------------------------------------------------------------------

// Low 2 is lower than low 1 and high 2 is lower than high 1

 if(Use_CCI == false) CCI = -101;
  if(Use_CCI_trend == false) CCI_trend = -101;

      if(
         p4                    >  p3                   &&
         p4                    <  p2                   &&
         //p4                    <  p1                   &&
         p3                    <  p2                   &&
         //p3                    <  p1                   &&
         //p2                    >  p1                   &&
         p5                    <  p4                   &&
         SELL                  <= Max_short_Orders     &&
         p3                    != p3_trade_short       &&
         CCI                   <  -100                 &&
         Bid                   <= p3                   &&
         new_trade_allowed     == true                 &&
         sell_allowed          == true                      //trend check
        )
       {
        StoppLoss  = NormalizeDouble(p3,4)+SL_Points*pips2dbl;
      if(Use_last_high_or_low_for_sl == true)
      {
       StoppLoss = p4;
       if(p4 - Bid  < Min_SL_Points*pips2dbl)
       StoppLoss  = NormalizeDouble(Bid,4)+Min_SL_Points*pips2dbl;
       if(p4 - Bid  > Max_SL_Points*pips2dbl)
       StoppLoss  = NormalizeDouble(Bid,4)+Max_SL_Points*pips2dbl;
      }
        TakeProfit = NormalizeDouble(p3,4)-TP_Points*pips2dbl;
        ticket=OrderSend(Symbol(),OP_SELL,lots,Bid,1,StoppLoss,TakeProfit,"Ordername",1,0,Red);
        p3_trade_short = p3;
        PauseTest();
      }

//Place sell finish-------------------------------------------------------------------

}
/////////////////////////////////////////////////////////////////////////////
void trendcheck()
{
 if(Use_trend==false)
 {
  buy_allowed = true;
  sell_allowed = true;
  return;
 }

 MA = iMA(Symbol(),0,MA_Period,0,MODE_EMA,PRICE_MEDIAN,1);
 if( Ask > MA + min_distance_to_MA * pips2dbl)
   buy_allowed = true;
   else buy_allowed = false;

 if( Bid < MA - min_distance_to_MA * pips2dbl)
   sell_allowed = true;
   else sell_allowed = false;
}


/////////////////////////////////////////////////////////////////////////////
void rescue()
{
if(Use_Rescue == false) return;
for(b=OrdersTotal()-1;b>=0;b--)
        {
         if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES)==true)
           {
                      if(
                         OrderType()                                           == OP_BUY &&
                         Bid + start_rescue_pips * pips2dbl - OrderOpenPrice() <= 0 &&
                         NormalizeDouble(OrderTakeProfit(),4) != NormalizeDouble((OrderOpenPrice()),4)
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderOpenPrice(),0,0);
                          PauseTest();
                         }

                      if(
                         OrderType()                                           == OP_SELL &&
                         OrderOpenPrice() - Ask + start_rescue_pips * pips2dbl <= 0 &&
                         NormalizeDouble(OrderTakeProfit(),4) != NormalizeDouble((OrderOpenPrice()),4)
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderOpenPrice(),0,0);
                          PauseTest();
                         }
            }
         }
}

/////////////////////////////////////////////////////////////////////////////
void Skip_SL_to()
{
if(Use_Skip_SL_to == true)
   {
    for(b=OrdersTotal()-1;b>=0;b--)
        {
         if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES)==true)
           {
               if (OrderType() == OP_BUY)
                    {
                      if(
                         Bid - OrderOpenPrice() >= SL_EDGE_1 * pips2dbl    &&                            //if trade is X-1 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  <  NormalizeDouble((OrderOpenPrice() + SL_profit_points_1 * pips2dbl),4)       //and the current stoploss is smaller than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() + SL_profit_points_1 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                         }

                      if(
                         Bid - OrderOpenPrice() >= SL_EDGE_2 * pips2dbl    &&                            //if trade is X-2 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  <  NormalizeDouble((OrderOpenPrice() + SL_profit_points_2 * pips2dbl),4)       //and the current stoploss is smaller than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() + SL_profit_points_2 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                         }

                      if(
                         Bid - OrderOpenPrice() >= SL_EDGE_3 * pips2dbl    &&                            //if trade is X-3 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  <  NormalizeDouble((OrderOpenPrice() + SL_profit_points_3 * pips2dbl),4)      //and the current stoploss is smaller than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() + SL_profit_points_3 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                          }
                      if(
                         Bid - OrderOpenPrice() >= SL_EDGE_4 * pips2dbl    &&                            //if trade is X-4 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  <  NormalizeDouble((OrderOpenPrice() + SL_profit_points_4 * pips2dbl),4)      //and the current stoploss is smaller than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() + SL_profit_points_4 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                          }
                      if(
                         Bid - OrderOpenPrice() >= SL_EDGE_5 * pips2dbl    &&                            //if trade is X-5 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  <  NormalizeDouble((OrderOpenPrice() + SL_profit_points_5 * pips2dbl),4)      //and the current stoploss is smaller than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() + SL_profit_points_5 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                          }
                      if(
                         Bid - OrderOpenPrice() >= SL_EDGE_6 * pips2dbl    &&                            //if trade is X-6 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  <  NormalizeDouble((OrderOpenPrice() + SL_profit_points_6 * pips2dbl),4)      //and the current stoploss is smaller than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() + SL_profit_points_6 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                          }
                      if(
                         Bid - OrderOpenPrice() >= SL_EDGE_7 * pips2dbl    &&                            //if trade is X-7 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  <  NormalizeDouble((OrderOpenPrice() + SL_profit_points_7 * pips2dbl),4)      //and the current stoploss is smaller than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() + SL_profit_points_7 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                          }
                     }

               if (OrderType() == OP_SELL)
                    {
                      if(
                         OrderOpenPrice() - Ask  >= SL_EDGE_1 * pips2dbl    &&                            //if trade is X-1 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  >  NormalizeDouble((OrderOpenPrice() - SL_profit_points_1 * pips2dbl),4)     //and the current stoploss is bigger than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() - SL_profit_points_1 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                         }

                      if(
                         OrderOpenPrice() - Ask >= SL_EDGE_2 * pips2dbl    &&                            //if trade is X-2 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  >  NormalizeDouble((OrderOpenPrice() - SL_profit_points_2 * pips2dbl),4)      //and the current stoploss is bigger than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() - SL_profit_points_2 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                         }

                      if(
                         OrderOpenPrice() - Ask >= SL_EDGE_3 * pips2dbl    &&                            //if trade is X-3 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  >  NormalizeDouble((OrderOpenPrice() - SL_profit_points_3 * pips2dbl),4)      //and the current stoploss is bigger than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() - SL_profit_points_3 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                         }
                      if(
                         OrderOpenPrice() - Ask >= SL_EDGE_4 * pips2dbl    &&                            //if trade is X-4 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  >  NormalizeDouble((OrderOpenPrice() - SL_profit_points_4 * pips2dbl),4)      //and the current stoploss is bigger than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() - SL_profit_points_4 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                         }
                      if(
                         OrderOpenPrice() - Ask >= SL_EDGE_5 * pips2dbl    &&                            //if trade is X-5 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  >  NormalizeDouble((OrderOpenPrice() - SL_profit_points_5 * pips2dbl),4)      //and the current stoploss is bigger than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() - SL_profit_points_5 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                         }
                      if(
                         OrderOpenPrice() - Ask >= SL_EDGE_6 * pips2dbl    &&                            //if trade is X-6 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  >  NormalizeDouble((OrderOpenPrice() - SL_profit_points_6 * pips2dbl),4)      //and the current stoploss is bigger than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() - SL_profit_points_6 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                         }
                      if(
                         OrderOpenPrice() - Ask >= SL_EDGE_7 * pips2dbl    &&                            //if trade is X-7 pips in profit
                         NormalizeDouble(OrderStopLoss(),4)  >  NormalizeDouble((OrderOpenPrice() - SL_profit_points_7 * pips2dbl),4)      //and the current stoploss is bigger than the wished one
                        )
                         {
                          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice() - SL_profit_points_7 * pips2dbl,4),OrderTakeProfit(),0,0);
                          PauseTest();
                         }
                     }
         }
      }
   }
}

/////////////////////////////////////////////////////////////////////////////

void draw_line()
{
 if (OrdersTotal() != OrdersTotal_old)
   {
    //check if last trade was a profit or a loss
       if (OrdersTotal() == 0 && OrdersTotal_old == 1)
         {
          int d = OrdersHistoryTotal();
          if(OrderSelect(d-1,SELECT_BY_POS,MODE_HISTORY)==true)
                     {
                       if (OrderProfit() < 0)
                       line_color = -1;
                       else line_color = 1;
                     }
   //drawing
         ObjectCreate("line_label"+number, OBJ_VLINE, 0, TimeCurrent(),0,0,0);
         ObjectSet("line_label"+number, OBJPROP_STYLE, STYLE_DOT);
         ObjectSet("line_label"+number, OBJPROP_WIDTH, 1);

         if (line_color == -1)
         ObjectSet("line_label"+number, OBJPROP_COLOR, Red);
         if (line_color == 1)
         ObjectSet("line_label"+number, OBJPROP_COLOR, Blue);
         if (line_color == 0)
         ObjectSet("line_label"+number, OBJPROP_COLOR, Black);
         number++;
         }
     }
   OrdersTotal_old = OrdersTotal();
}
/////////////////////////////////////////////////////////////////////////////


void PauseTest()
{
 if(Use_Pause == false) return;
 datetime now = TimeCurrent();
 static datetime oncePerTick;

    if (IsTesting() && IsVisualMode() && IsDllsAllowed() && oncePerTick != now)
    {
     oncePerTick = now;
      for(int i=0; i<200000; i++)
      {       // Delay required for speed=32 (max)
       int main = GetAncestor(WindowHandle(Symbol(), Period()), 2/*GA_ROOT*/);
       if (i==0) PostMessageA(main, WM_COMMAND, 0x57a, 0); // 1402. Pause
      }
    }
}


